LeetCode 3: Longest Substring Without Repeating Characters

来源:互联网 发布:安卓与php交互 编辑:程序博客网 时间:2024/06/07 05:27

题目描述:

Given a string, find the length of the longest substring without repeating characters.

Examples:

Given "abcabcbb", the answer is"abc", which the length is 3.

Given "bbbbb", the answer is"b", with the length of 1.

Given "pwwkew", the answer is"wke", with the length of 3. Note that the answer must be asubstring,"pwke" is asubsequence and not a substring.


思路:如:abcdef是个不重复的子串,abcdefc中(为了方便记录为abc1defc2),c1和c2重复了。那么下一次搜寻,应该跨过出现重复的地方进行,否则找出来的候选串依然有重复字符,且长度还不如上次的搜索。所以下一次搜索,直接从c1的下一个字符d开始进行。


方法一:出现“Time Limit Exceeded”,时间复杂度O(n)

public int lengthOfLongestSubstring1(String s) {        if(s.length() == 1 || s.length() == 0)            return s.length();        int maxLen = 0;        int i = 0, j;        j = i + 1;        while(j < s.length()){            String subStr = s.substring(i, j);            if(subStr.contains(String.valueOf(s.charAt(j)))){                if(subStr.length() >= maxLen){                    maxLen = subStr.length();                }                i = i + subStr.indexOf(s.charAt(j)) + 1;                j = i + 1;            } else {                ++j;            }        } // while        String lastSubStr = s.substring(i, j);        if(lastSubStr.length() >= maxLen){            maxLen = lastSubStr.length();        }        return maxLen;    }

方法二:空间换时间,利用hashmap存储不重复子串,key为字符,value为此字符的位置。从前向后进行遍历,只要map 中没有当前字符,便将其加入map 。并将子串长度加一。若当前字符已经出现在map 中,获得map中 此字符的位置,清除此位置以及之前的的所有key 。从此位置之后重新计算子串,保证了子串的不重复。

public int lengthOfLongestSubstring(String s) {        if(s == null) return 0;        HashMap<Character, Integer> map = new HashMap<Character, Integer>();        int start = 0;        int maxLen = 0;        int len = 0;        for(int i = 0; i < s.length(); i++){            if(!map.containsKey(s.charAt(i))){                len++;                if(len > maxLen)                    maxLen = len;                map.put(s.charAt(i), i);            }else{                int index = map.get(s.charAt(i));                for (int j = start; j <= index; j++){                    map.remove(s.charAt(j));                }                map.put(s.charAt(i), i);                start = index+1;                len = i-index;            }        }        return maxLen;    }



阅读全文
0 0
原创粉丝点击